From 7b668b35cbc186ecff48e85a812566df56b9afc1 Mon Sep 17 00:00:00 2001
From: Alexander Polakov <polachok@gmail.com>
Date: Sun, 29 May 2011 15:12:31 +0400
Subject: [PATCH 2/9] ksh/vi: Ctrl-l in insert mode to clear the screen.

 Why: typing "clear" is too slow.
---
 ksh.1 |    3 +++
 vi.c  |    6 ++++++
 2 files changed, 9 insertions(+), 0 deletions(-)

diff --git a/ksh.1 b/ksh.1
index 0992964..19784dd 100644
--- a/ksh.1
+++ b/ksh.1
@@ -5213,6 +5213,9 @@ List all the commands or files that match the current big-word.
 Macro expansion.
 Execute the commands found in the alias
 .Ar c .
+.It ^L
+Clear the screen leaving the current line at the top of the
+screen.
 .El
 .Pp
 Intra-line movement commands:
diff --git a/vi.c b/vi.c
index e4173c7..d0de478 100644
--- a/vi.c
+++ b/vi.c
@@ -646,6 +646,12 @@ vi_insert(int ch)
 			return redo_insert(lastac - 1);
 
 	/* { Begin nonstandard vi commands */
+	case Ctrl('l'):
+		/* Use ANSI escape codes to clear the screen */
+		x_puts("\033[2J\033[0;0H");
+		redraw_line(0);
+		break;
+
 	case Ctrl('x'):
 		expand_word(0);
 		break;
-- 
1.7.6

